<?php

namespace Drupal\rest_invalidate_cache\Plugin\rest\resource;

use Drupal\Core\Cache\Cache;
use Drupal\rest\Plugin\ResourceBase;
use Drupal\rest\ResourceResponse;

/**
 * @RestResource(
 *   id = "rest_invalidate_cache_invalidate",
 *   label = @Translation("Invalidate cache"),
 *   uri_paths = {
 *     "create" = "/invalidate_cache/{tags}"
 *   }
 * )
 */
class InvalidateCache extends ResourceBase {

  /**
   * @param string $tags
   *
   * @return \Drupal\rest\ResourceResponse
   */
  public function post(string $tags): ResourceResponse {
    $tagList = explode(',', $tags);
    Cache::invalidateTags($tagList);

    return new ResourceResponse(
      [
        'message' => $this->t(
          'Tags invalidated: @tags',
          ['@tags' => implode(', ', $tagList)]
        ),
      ]
    );
  }

}
